from wooly import *
from wooly.widgets import *
from wooly.forms import *
from wooly.resources import *

from widgets import *
from parameters import *
from util import *

strings = StringCatalog(__file__)

class RealmSet(ItemSet):
    def render_title(self, session, vhost):
        return "Realms %s" % fmt_count(len(vhost.realm_items()))

    def do_get_items(self, session, vhost):
        return sorted_by(vhost.realm_items())

    def render_item_name(self, session, realm):
        return realm.name

class RealmInputSet(CheckboxInputSet):
    def __init__(self, app, name):
        super(RealmInputSet, self).__init__(app, name)
        
        param = ListParameter(app, "param", RealmParameter(app, "item"))
        self.add_parameter(param)
        self.set_parameter(param)

    def do_get_items(self, session, vhost):
        return sorted_by(vhost.realm_items())

    def render_item_value(self, session, realm):
        return realm.id

    def render_item_content(self, session, realm):
        return realm.name

    def render_item_checked_attr(self, session, realm):
        return realm in self.param.get(session) and "checked=\"checked\""
