import logging

from wooly import *
from wooly.widgets import *
from wooly.forms import *
from wooly.resources import *
from wooly.tables import *

from widgets import *

strings = StringCatalog(__file__)
log = logging.getLogger("cumin.job")

# XXX marked for death
class UniqueSlot(CuminTable):
    def get_recent_sql_where(self, session):
        return """
            s.qmf_update_time > now() - interval '60 minutes'
            """

    def do_get_items(self, session, *args):
        cursor = super(UniqueSlot, self).do_get_items(session, *args)
        items = self.cursor_to_rows(cursor)
        self.items.set(session, items)
        return items

class SlotSet(UniqueSlot):
    def __init__(self, app, name):
        super(SlotSet, self).__init__(app, name)

        col = self.Name(app, "name")
        self.add_column(col)
        
    class Name(SqlTableColumn):
        def render_title(self, session, data):
            return "Name"

    def render_items(self, session, *args):
        """ overridden because a slotset query is expensive.
            the rows are cached """
            
        rows = self.get_items(session, *args)
        writer = Writer()

        for row in rows:
            self.item_tmpl.render(writer, session, row)
        
        return writer.to_string()

class MachineSet(UniqueSlot):
    pass

class SlotStatSet(UniqueSlot):
    pass
