from threading import RLock

class MintCache(object):
  def __init__(self):
    self.__cache = dict()
    self.__pending = dict()
    self.__dirty = False

  def get(self, key):
    try:
      return self.__cache[key]
    except KeyError:
      return self.__pending.get(key)

  def set(self, key, value):
    self.__pending[key] = value
    self.__dirty = True

  def commit(self):
    self.__cache.update(self.__pending)
    self.__pending.clear()
    self.__dirty = False

  def rollback(self):
    self.__pending.clear()
    self.__dirty = False

  def isDirty(self):
    return self.__dirty
