from logging import *

levels = {
    "debug": DEBUG,
    "info": INFO,
    "warn": WARN,
    "error": ERROR,
    "critical": CRITICAL
    }

def enable_logging(name, level, file):
    assert level
    assert file

    if type(level) is str:
        level = levels[level.lower()]

    if type(file) is str:
        file = open(file, "a")

    handler = StreamHandler(file)

    fmt = "%(process)d %(asctime)s %(levelname)s %(message)s"
    handler.setFormatter(Formatter(fmt))

    log = getLogger(name)
    log.addHandler(handler)
    log.setLevel(level)
